#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>

#define BUFSIZE 1024

int main(int argc, char **argv)
{
	int clnt_sock;
	struct sockaddr_in serv_addr;
	char message[BUFSIZE];
	int str_len;

	if(argc != 3) {
		printf("Usage : %s <IP> <port> \n", argv[0]);
		exit(1);
	}

	clnt_sock = socket(PF_INET, SOCK_STREAM, 0);   /* 서버 접속을 위한 소켓 생성 */

	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = inet_addr(argv[1]);
	serv_addr.sin_port = htons(atoi(argv[2]));

	connect(clnt_sock, (struct sockaddr*)&serv_addr, sizeof(serv_addr));

	while(1) {
		/* 메시지 입력 전송*/
		fputs("Input your message (q to quit) : ", stdout);
		fgets(message, BUFSIZE, stdin);
		if(!strcmp(message, "q\n"))
			break;
		write(clnt_sock, message, strlen(message));

		/* 메시지 수신 출력 */
		str_len = read(clnt_sock, message, BUFSIZE-1);
		message[str_len] = 0;
		printf("Received message from server : %s \n", message);
	}

	close(clnt_sock);
	return 0;
}
