#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char **argv)
{
	int clnt_sock;
	struct sockaddr_in serv_addr;

	char buf_in[255];
	char buf_get[255];

	if (argc != 3) {
		printf("Usage : %s <IP> <port> \n", argv[0]);
		exit(1);
	}

	clnt_sock = socket(AF_INET, SOCK_STREAM, 0);  /* 서버 접숙을 위한 소켓 생성 */

	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = inet_addr(argv[1]);
	serv_addr.sin_port = htons(atoi(argv[2]));

	if (connect(clnt_sock, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) < 0) {
		perror("Connect error: ");
		exit(0);
	}
	while(1) {

		/* 서버에 전달할 Request 입력 */
		printf("Input Name : ");
		fgets(buf_in, 255,stdin);

		buf_in[strlen(buf_in) - 1] = '\0';
		/* Request 서버로 전송 */
		write(clnt_sock, buf_in, 255);
		if (strncmp(buf_in, "quit", 4) == 0)
		{
			close(clnt_sock);
			exit(0);
		}
		while(1) {
			/* 서버의 Response 수신 */
			read(clnt_sock, buf_get, 255);
			if (strncmp(buf_get, "end", 3) == 0)
 				break;

			printf("%s", buf_get);
		}
		printf("\n\n");
	}

	close(clnt_sock);
	exit(0);
}

